//=============================================================================
// 쌠 ATMEL Corporation 2003. S\ς
//
// ̧:		CreateException.h
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMELٳ)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		Opٰ
//
// ̑:
//=============================================================================

#ifndef CREATEEXCEPTION_H
#define CREATEEXCEPTION_H

typedef enum
{
	ERROR_OK,
	ERROR_FILE_NOT_FOUND,
	ERROR_CONFIGURATION_PARAMETER,
	ERROR_HEX_FORMAT,
	ERROR_FILE_DAMAGED,
	ERROR_KEY,
	ERROR_KEY_PARITY,
	ERROR_INITIAL_VECTOR,
	ERROR_SIGNATURE,
	ERROR_OUT_OF_MEMORY,
	ERROR_CREATE_FILE,
	ERROR_OVERLAPPING_DATA,
	ERROR_UNKNOWN_ARGUMENT,
	ERROR_CONFIG_NOT_DEFINED,
	ERROR_PAGE_SIZE_REQUIRED,
	ERROR_CRC,
	ERROR_KEY_NOT_DEFINED,
	ERROR_NUM
} ErrorCode;

class CreateException
{
	ErrorCode codeM;			// ُ필ԍ
	char *reasonM;				// OɊւ闝RLq镶

public:
	CreateException(ErrorCode code, const char *offender);
	virtual ~CreateException();
	char *getReason();
	ErrorCode getCode();
};

#endif // CREATEEXCEPTION_H
