//=============================================================================
// 쌠 ATMEL Corporation 2003. S\ς
//
// ̧:		DES.h
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// Ǝ:	OE, VU
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		葽̏ɂĂ͉pLqQƂĂB
//
//				DES̏ڍׂɂĂ͈ȉ̌FIPS 46-3QƂĂB
//				http://csrc.nist.gov/publications/fips/fips46-3/fips46-3.pdf
//
// ̑:	0̑1Ŏn܂FIPS̏\Ȃ̐̂߁A{̧ٓ
//				SĂ̏\̐1ȂłBƁA̧ٓ̕\͐擪
//				ޯĂƂ0ŎwĂ܂B
//=============================================================================

#ifndef DES_H
#define DES_H

#include "DataBuffer.h"

class Des
{
public:
	Des(DataBuffer& initialVector);
	virtual ~Des();

	void scheduleKey(DataBuffer key[3]);
	DataBuffer getK(int key, int index);
	void encrypt(unsigned char *buffer, const unsigned char *chainBlock);
	void encryptBuffer(DataBuffer& Buffer);

private:
	unsigned char chainBlockM[8];
	unsigned char kTableM[3][16][6];
	
	unsigned char getBit(const unsigned char *table, unsigned char index);
	void putBit(unsigned char *table, unsigned char index, unsigned char value);
	void permute(unsigned char size, unsigned char *out,
				 const unsigned char *in, const unsigned char *table);
	void xor(unsigned char byte_count, unsigned char *left,
			 const unsigned char *right);
	void s(unsigned char *OutData, const unsigned char *InData);
};

#endif // DES_H
