//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		usart1.c
// ߲:		IAR Atmel AVR C/EC++߲
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		USART̪
//
// ̑:
//=============================================================================

#include <inavr.h>
#include <ioavr.h>
#include "bus.h"

//=============================================================================
// ޽ ̪

void busInit(void)
{
	// 9600ް/8.00MHz
	UBRR1L = 51;

	// M
	UCSR1B = (1 << RXEN1) + (1 << TXEN1);
}

//=============================================================================
// ޽(̏ꍇAŏ޲ēҋ@)

void busPrepare(void)
{
	while (!(UCSR1A & (1 << RXC1)));
}

//=============================================================================
// ޲ĎM

unsigned char busReceiveByte(void)
{
	busPrepare();

	return UDR1;
}

//=============================================================================
// ޽𑽖ZԂɐݒBUSARTł̊KvB

void busBusy(void)
{
	return;
}

//=============================================================================
// ޲ĕԓ

void busReplyByte(unsigned char data)
{
	busPrepare();
	UDR1 = data;
}
