//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		ConfigParser.h
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		ConfigParser׽͌`Ԑݒ̧ق͂܂B
//
//				葽̏ɂĂ͉pLqQƂĂB
//
// ̑:
//=============================================================================

#ifndef CONFIGPARSER_h
#define CONFIGPARSER_h

#include "databuffer.h"

class ConfigParser
{
private:
	int pageSizeM;				// ړIΏAVR(޲Ăł)߰ޗe
	int memSizeM;				// p̈(޲Ăł)e

	int keyCountM;				// DESÍ̌
	DataBuffer keyM[3];			// DESÍ

	DataBuffer initialVectorM;	// CBCp޸
	DataBuffer signatureM;		// Lڰьؗpڰю[

	bool crcFlashEnableM;		// p̈CRCvZL

public:
	ConfigParser(char *filename);
	virtual ~ConfigParser();

	int getPageSize() { return pageSizeM; };
	int getMemSize() { return memSizeM; };
	int getKeyCount() { return keyCountM; };
	DataBuffer& getKey(int index) { return keyM[index]; };
	DataBuffer *getKeys() { return keyM; };

	DataBuffer& getInitialVector() { return initialVectorM; };
	DataBuffer& getSignature() { return signatureM; };
	bool getCRCFlashEnable() {return crcFlashEnableM; };
};

#endif // CONFIGPARSER_H
